=== debian/changelog ===
massxpert (7.0.0-2) unstable; urgency=low

  * d/control: update version of daps dependency package to 3.3.2;
  * d/control: remove useless build dependencies;
  * debian/source/lintian-overrides: reinstate.

 -- Filippo Rusconi <lopippo@debian.org>  Mon, 19 Dec 2022 17:35:50 +0100

massxpert (7.0.0-1) unstable; urgency=low

  * Major release with all the code ported to Qt6. This release is a Qt6-based
    build.

 -- Filippo Rusconi <lopippo@debian.org>  Mon, 31 Oct 2022 21:31:52 +0100
